require 'tennpipes-base/command'

module Tennpipes
  ##
  # This method return the correct location of tennpipes-init bin or
  # exec it using Kernel#system with the given args.
  #
  # @param [Array<String>] args.
  #   Splat of arguments to pass to tennpipes-init.
  #
  # @example
  #   Tennpipes.bin_gen(:app, name.to_s, "-r=#{destination_root}")
  #
  def self.bin_gen(*args)
    @_tennpipes_gen_bin ||= [Tennpipes.ruby_command, File.expand_path("../../../bin/tennpipes-init", __FILE__)]
    system args.unshift(@_tennpipes_gen_bin).join(" ")
  end
end
